<!DOCTYPE html>
<html lang="en">
<head>
  <title>Project selection screen</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>

  <style type="text/css">
      .hide-this {
          display: none;
      }
  </style>
</head>
<body>

<div class="container">
  <h2>Project details</h2>
  <form onsubmit="collectProjectCreationDetails(event)">
    <div class="form-group">
      <label for="project-name">Project name</label>
      <input type="text" class="form-control" id="project-name" placeholder="Enter project name" name="project-name">
    </div>
    <div class="form-group">
      <label for="path">Path</label>
      <input type="text" class="form-control" id="path" placeholder="Enter path" name="path">
    </div>
    
    <div class="form-group">
      <label for="page-name">Page name</label>
      <input type="text" class="form-control" id="page-name" placeholder="Enter page name" name="page-name">
    </div>

    <div class="alert alert-success alert-dismissible hide-this" id='success-msg'>
        <a href="#" class="close" data-dismiss="alert" aria-label="close">&times;</a>
        <strong>Success!</strong> Project successfully created
    </div>

    <button type="submit" class="btn btn-success">Create</button>
  </form>

  <hr>

  <h2>Project directory structure</h2>
  
  <div style="width: 100%; height: 500px;" editable="true">
      <pre id='dirs'>

      </pre>
  </div>
</div>

<script type="text/javascript" src="../app/get-directory-tree.js"></script>
<script type="text/javascript">

function collectProjectCreationDetails(event) {
    event.preventDefault();

    let projectName = document.getElementById("project-name").value;
    let path = document.getElementById('path').value;
    let fileName = document.getElementById('page-name').value;

    console.log(projectName);
    console.log(path);

    takeActionForProjectCreation(projectName, path, fileName);
}

function checkFileNameForExtension(fileName, extension = 'html') {
    /**
        + Check file name, if it is incorrect use 'index.html' as default one
        + If no extension is provided but file name is pure alphabetic, add 'html' as extension
    */
    try {
        if(!(/[a-zA-Z]+.html$/.test('' + fileName))) { // A12.html, index.html, web1992.html
            if(/^[a-zA-z][a-zA-Z0-9]+$/.test('' + fileName)) { // A, index, tiger67
                console.log('Got - 1');
                fileName = fileName + '.' + extension; // A.html, index.html, tiger67.html
            } else {
                console.log(`Got - 2`);
                fileName = 'index.' + extension; // index.html
            }
        };

        console.log('File name is correct: ' + `${fileName}`);
        return fileName; // index.html, about.html, prodcuts.html,
                         // contact.html, login.html, logout.html
    } catch(err) {
        console.log(`Error: ${err}`);
        return false; // Signal of an error
    }
}

function takeActionForProjectCreation(projectName, projectParentPath, fileName, showDirs = true, ...args) {
    try {
        const fs = require('fs'); // File system
        const path = require('path'); // Paths 
        const copydir = require("copy-dir"); // To copy directories

        fs.accessSync(projectParentPath, fs.constants.F_OK); // Exists
        console.log('Path is okay');

        // Create project directory
        let projectPath = `${projectParentPath}${path.sep}${projectName}`; // Path to settings.json
        
        fs.mkdirSync(`${projectPath}${path.sep}.pypsi`, {
            recursive: true
        });

        console.log('Folder created, done');

        const d = new Date();
        let dataSrc = path.resolve(`data`);
       
        projectName =  /^[a-zA-Z][a-zA-Z0-9]+$/.test(projectName)? projectName: projectName.replace(/[^a-zA-Z0-9]/g, '') + 'Project';

        let settings = {
            projectName: projectName,
            projectPath: projectPath,
            projectRoot: projectParentPath,
            created: '' + d,
            shortCreated: d.getDate() + '/' + (d.getMonth() + 1) + '/' + d.getFullYear()
        };

        copydir.sync(dataSrc, projectPath); // src, destination (Copying assets directory), path to assets copies all the folders

        fs.writeFileSync(`${projectPath}${path.sep}.pypsi${path.sep}settings.json`, JSON.stringify(settings, null, 4));


        fileName = checkFileNameForExtension(fileName);
        let onlyName = fileName.split('.')[0];
        console.log('Selected file name');

        let names = ['css', 'js'];
        for(let i=0; i < names.length; ++i) {
            console.log(`Done more now`);

            fs.writeFileSync(`${projectPath}${path.sep}assets${path.sep}${names[i]}${path.sep}${onlyName}.${names[i]}`, `/* Write your ${names[i].toUpperCase()} here */`);  
        }

        let htmlText = `
            <!DOCTYPE html>
            <h1>PyPsi</h1>
        `

        fs.writeFileSync(`${projectPath}${path.sep}views${path.sep}${fileName}`, htmlText);

        const directoryTreeObj = getChildren(projectPath);

        if(showDirs) {
            const dirs = JSON.stringify(directoryTreeObj, null, 4);
            document.getElementById('dirs').innerText = dirs;
            console.log(dirs);
        }

        setTimeout(function() {
            let successMsg = document.getElementById('success-msg');
            successMsg.style.display = 'block';

            setTimeout(function() {
                successMsg.style.display = 'none';
            }, 3000);
        }, 200);

        return directoryTreeObj; // Will be helpful for UI developers
    } catch (err) {
        console.log(`Error (Project selection): ${err}`);
        alert(`Entered path does not exist in the system. ${err}`);

        return false; // Signal of an error
    }
}
</script>
</body>
</html>
